import { ValidateBy, ValidationOptions, buildMessage } from 'class-validator';

export const IsConfigurationType = (
  validationOptions?: ValidationOptions,
): PropertyDecorator =>
  ValidateBy(
    {
      name: '',
      constraints: [],
      validator: {
        validate: (value: any): boolean =>
          typeof value === 'number' ||
          typeof value === 'boolean' ||
          typeof value === 'string',
        defaultMessage: buildMessage(
          () => `Value must be a number, boolean or string`,
          validationOptions,
        ),
      },
    },
    validationOptions,
  );
