import { ConfigurationDomain } from '@mobicoop/configuration-module';
import { IsEnum, IsNotEmpty, IsString } from 'class-validator';
import { IsConfigurationType } from './is-configuration-type.decorator';

export class SetConfigurationRequestDto {
  @IsEnum(ConfigurationDomain)
  @IsNotEmpty()
  domain: ConfigurationDomain;

  @IsString()
  @IsNotEmpty()
  key: string;

  @IsConfigurationType()
  @IsNotEmpty()
  value: string | boolean | number;
}
