import { ConfigurationsManagerService } from '@modules/configuration/core/application/services/configurations-manager.service';
import { ConfigService } from '@nestjs/config';
import { Test, TestingModule } from '@nestjs/testing';

const mockConfigService = {
  get: jest.fn().mockImplementation((domain: string) => {
    switch (domain) {
      case 'carpool':
        return {
          departureTimeMargin: 900,
          role: 'passenger',
          seatsProposed: 3,
          seatsRequested: 1,
          strictFrequency: false,
        };
      case 'pagination':
        return {
          perPage: 10,
        };
    }
  }),
};

describe('Configurations Manager Service', () => {
  let configurationsManagerService: ConfigurationsManagerService;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        {
          provide: ConfigService,
          useValue: mockConfigService,
        },
        ConfigurationsManagerService,
      ],
    }).compile();

    configurationsManagerService = module.get<ConfigurationsManagerService>(
      ConfigurationsManagerService,
    );
  });

  it('should be defined', () => {
    expect(configurationsManagerService).toBeDefined();
  });
});
